/*
 *      @(#)Copyright (c) 1996 Simon J. Gerraty.
 *      
 *      This is free software.  It comes with NO WARRANTY.
 *      Permission to use, modify and distribute this source code 
 *      is granted subject to the following conditions.
 *      1/ that the above copyright notice and this notice 
 *      are preserved in all copies and that due credit be given 
 *      to the author.  
 *      2/ that any changes to this code are clearly commented 
 *      as such so that the author does not get blamed for bugs 
 *      other than his own.
 *      
 *      Please send copies of changes and bug-fixes to:
 *      sjg@crufty.net
 */
#ifndef lint
static char RCSid[] = "$Id: copy.c,v 1.8 2002/12/13 23:08:32 sjg Exp $";
#endif
#ifdef HAVE_CONFIG_H
# include "config.h"
#endif
#include <stdio.h>
#if defined(HAVE_UNISTD_H)
#include <unistd.h>
#endif
#if defined(HAVE_SYSLOG_H)
#include <syslog.h>
#endif
#include <errno.h>

#include "sslfd.h"

static int _timeout = 0;

void
copy_timeout(secs)
	int secs;
{
	_timeout = secs;
}

int
copy_net(s1, s2)
	int s1, s2;
{
	char buf[BUFSIZ];
	int n, w, x, t;

	n = w = x = t = 0;

	for (;;) {
		if (_timeout)
			alarm(_timeout);

		n = read_net(s1, buf, sizeof(buf));

		if (_timeout)
			alarm(0);
	
		if (n < 0) {
#ifdef DEBUG
			syslog(LOG_DEBUG, "copy(%d,%d) n=%d, errno=%d: %m",
			       s1, s2, n , errno);
#endif
			if (errno == EINTR)
				continue;
			break;
		}
		
		if (n == 0)
			break;
		for (x = 0; x < n; ) {
			w = write_net(s2, &buf[x], n - x);
			if (w <= 0)
				return -1;
			x += w;
			t += w;
		}
	}
#ifdef DEBUG
	syslog(LOG_DEBUG, "copy(%d,%d) n=%d, w=%d: %m",
	       s1, s2, n , w);
#endif
	return t;
}
